/*
 * MP3 Player, ATAPI support.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * Contact: paul@pjrc.com
 *
 * File		: atapi.h
 * Author	: MBA
 * Created	: dec, 2001
 *
 */

#include "malloc.h"

#ifndef _ATAATAPI_H_ 
#define _ATAATAPI_H_ 

#define true 1
#define false 0

typedef unsigned char STRING_Z;

#define cmdATAPI_REQUEST_SENSE	0x03
#define cmdATAPI_READ_CAPACITY	0x25
#define cmdATAPI_READ_TOC	0x43
#define cmdATAPI_START_STOP	0x1B
#define cmdATAPI_READ		0xA8

typedef struct
{
  unsigned long ulExtentMax;
  unsigned long ulExtentStart;
} AtapiDevicePropertiesType;


// moet wel 1 struct zijn om de userdata te kunnen bewaren !!!!!!!!!!!

typedef struct
{
  STRING_Z      szName[64];
  unsigned long ulExtent;
  unsigned long ulUserData;
} /*ATAPI_DIR_STRUCT, *PATAPI_DIR_STRUCT,*/ AtapiDirStructType, *AtapiDirStructTypePtr;
typedef simm_id AtapiDirStructTypeSid;

typedef struct
{
  STRING_Z      szName[64];
  unsigned long ulExtent;
  unsigned long ulDataLength;
} /*ATAPI_FILE_STRUCT, *PATAPI_FILE_STRUCT,*/ AtapiFileStructType, *AtapiFileStructTypePtr;
typedef simm_id AtapiFileStructTypeSid;

typedef unsigned char AtapiPacketBufferType[12], AtapiPacketBufferTypePtr[12];

extern void AtapiFileReadInit(unsigned char p_ucDevice);
#pragma CALLEE-SAVES AtapiFileReadBlock
extern unsigned int AtapiFileReadBlock(unsigned char p_ucDevice);
#pragma CALLEE-SAVES AtapiFileUncache
extern char AtapiFileUncache(unsigned char p_ucDevice);
#pragma CALLEE-SAVES AtapiFileCache
extern char AtapiFileCache(unsigned char p_ucDevice,
                    unsigned long p_ulExtent,
                    unsigned long p_ulLength);


#pragma CALLEE-SAVES AtapiReadSector2
extern char AtapiReadSector2(unsigned char p_ucDevice,
                             unsigned long p_ulExtent);
#pragma CALLEE-SAVES AtapiReadSector
extern char AtapiReadSector(unsigned char p_ucDevice,
                            unsigned char p_ucLBA0,
                            unsigned char p_ucLBA1,
                            unsigned char p_ucLBA2,
                            unsigned char p_ucLBA3);
char AtapiRequestSense(unsigned char p_ucDevice);
char AtapiEject(unsigned char p_ucDevice);
char AtapiReadCapacity(unsigned char p_ucDevice);

void AtapiWriteData(unsigned char* p_paucData,
                    unsigned char  p_ucWordCnt);

void AtapiReadData(unsigned char* p_paucData,
                   unsigned int   p_uiWordCnt);

char AtapiStartStop(unsigned char p_ucDevice, char bStart);
unsigned char AtapiVolumeRecognitionSequence(unsigned char p_ucDevice,
                                             unsigned long p_ulStartLSN);
int AtapiReadDirFiles(unsigned char p_ucDevice);
char AtapiReadTOC(unsigned char p_ucDevice);
char AtapiSendCommand(unsigned char  p_ucDev,
                      unsigned int   p_uiCdbSize,
                      unsigned char* p_paucCdb,
                      unsigned int   p_uiBufferSize,
                      unsigned char* p_paucBuffer);
void AtapiDirListCreate(unsigned char p_ucDevice);
void AtapiDirListDelete(unsigned char p_ucDevice);
#pragma CALLEE-SAVES AtapiDirListIterateInit
void AtapiDirListIterateInit(unsigned char p_ucDevice);
unsigned char AtapiDirListIterateNext(unsigned char p_ucDevice,
                                      simm_id*      p_psidDirEntry,
                                      simm_id*      p_psidDirParent);
#pragma CALLEE-SAVES AtapiDirListUserDataSet
void AtapiDirListUserDataSet(simm_id       p_sidDirEntry,
                             unsigned long p_ulUserData);
#pragma CALLEE-SAVES AtapiDirListUserDataGet
void AtapiDirListUserDataGet(simm_id        p_sidDirEntry,
                             unsigned long* p_pulUserData);
void AtapiFileListCreate(unsigned char p_ucDevice,
                         simm_id       p_sidDirEntry);
void AtapiFileListDelete(unsigned char p_ucDevice);
#pragma CALLEE-SAVES AtapiFileListIterateInit
void AtapiFileListIterateInit(unsigned char p_ucDevice);
#pragma CALLEE-SAVES AtapiFileListIterateNext
unsigned char AtapiFileListIterateNext(unsigned char p_ucDevice,
                                       simm_id*      p_psidFileEntry);
#endif
