#ifndef PLAYLIST_H
#define PLAYLIST_H 1

#include "malloc.h"

struct playlist_list_struct {
        simm_id name;
	unsigned int num_files;
        simm_id /* struct playlist_list_struct */ prev_sequential;
        simm_id /* struct playlist_list_struct */ next_sequential;
        simm_id /* struct playlist_struct */ playlist_start_sequential;
        simm_id /* struct playlist_struct */ playlist_end_sequential;
        simm_id /* struct playlist_list_struct */ prev_random;
        simm_id /* struct playlist_list_struct */ next_random;
        simm_id /* struct playlist_struct */ playlist_start_random;
};

typedef xdata struct playlist_list_struct playlist_list_t;

struct playlist_struct {
        simm_id /* struct filelist_struct */ fl_rec;
	simm_id /* struct playlist_list_struct */ playlist;
        simm_id /* struct playlist_struct */ prev_sequential;
        simm_id /* struct playlist_struct */ next_sequential;
        simm_id /* struct playlist_struct */ prev_random;
        simm_id /* struct playlist_struct */ next_random;
	char is_randomized;
};

typedef xdata struct playlist_struct playlist_t;

extern simm_id first_playlist;       /* in list of playlists */
extern simm_id last_playlist;        /* in list of playlists */ 

extern simm_id current_playlist;

extern void playlist_init();
extern void playlist_create(simm_id pl_name);
extern void playlist_add_file(simm_id fl_rec);
extern void playlist_show();
extern void playlist_show_all();

extern simm_id next_file_ptr(playlist_t *p);
extern simm_id prev_file_ptr(playlist_t *p);
extern simm_id next_playlist_ptr(playlist_t *p);
extern simm_id prev_playlist_ptr(playlist_t *p);

extern void playlist_show_rand(void);
extern void randomize_one_playlist(simm_id /* playlist_list_t */ list_id);

#define next_file(ID) (next_file_ptr((playlist_t *)addr6(ID)))
#define prev_file(ID) (next_file_ptr((playlist_t *)addr6(ID)))
#define next_playlist(ID) (next_playlist_ptr((playlist_t *)addr6(ID)))
#define prev_playlist(ID) (next_playlist_ptr((playlist_t *)addr6(ID)))


#endif
